<?php
/*
============================================================
    RemoveExpiredPage for CMSimple
  ============================================================
    Version:    1.1.2
    Copyright:   simpleSolutions september 2008
    Website:    http://simplesolutions.dk
    
    ChangeLog
    version 1.1.0
    * expiration date is the last day the page is visible. 
      Removepage(20081231) is removed on January 1 2009 00:00 am 
    * It's not necessary to initialize plugin in the template. 
      After updatte from version 1.0 remove <?php expiredpage();?> from your template. 
    * added logning of removes.
    version 1.1.1
    * bug fix -action parameter works as described.
    * test part of help file corrected.
    version 1.1.2
    * changed call to eregi
  ============================================================
*/
$plugin=basename(dirname(__FILE__),"/");

//***************************************************************
// Dummy call from the page to be removed
// #CMSimple removepage(20080924);#
//***************************************************************
function removepage($d) {
 	return "";  
}

// autorun
expiredpage();

function expiredpage()
{
	global $c, $h, $edit, $adm, $pth, $cf, $plugin_cf;
	if (!is_file($pth['file']['content'])) return "";
	@include "config/config.php";
	
	$timezone=(intval($plugin_cf['expiredpage']['time_zone']) + intval(date("I")))*60*60;
	$today = gmdate("Ymd",time()+$timezone);
	
	$logfile="./".$cf['plugins']['folder']."/expiredpage/log.txt";
	//run once af day or if plugin_cf['expiredpage']['test'] is sat to true
	if((intval(gmdate("Ymd",filectime($logfile)+$timezone)) < intval($today) || stristr($plugin_cf['expiredpage']['test'],"true"))) {
//echo $today."-".gmdate("Ymd",filectime($logfile)+$timezone);
 	 	$t_edit=$edit; $t_adm=$adm; $edit=true; $adm=true; // force reading of removed pages
 	 	$update_content=false;
		rfc(); // get content
		$fh = fopen($logfile, "a");		//the timestamp of logifle is a referance to run check of pages
    for($i=1;$i<sizeof($c);$i++) {  
		  $test=0;
		  if (!preg_match("/#CMSimple[ ]+".$plugin_cf['expiredpage']['action']." *#/i",$c[$i])) { // only one remove pr page in test
  			if (preg_match("/#CMSimple[ ]+removepage\(\d+\) *; *#/i",$c[$i],$matches)) {
	  		 preg_match("/\d{8}/",$matches[0],$remove_date);
 	  		 if ($remove_date[0]==99999999) $test=1;
	   		  if ((intval($remove_date[0]) < intval($today) && (strlen($remove_date[0])==8)) || $test){
 		  		  $c[$i]=preg_replace("/removepage\(\d+\) *;/",$plugin_cf['expiredpage']['action'], $c[$i]);
 		  		  $update_content=true;
 		  		  fwrite($fh,"$today: removed ".$h[$i]."\n");
			   		if ($test) {
              if (preg_match("/#CMSimple[ ]+".$plugin_cf['expiredpage']['action']." *#/i",$c[$i],$m)) { 
                $c[$i]=preg_replace("/".$m[0]."/",$m[0].$matches[0], $c[$i]);
              }
            }
				  }
		    }
      }
	  }
	  fclose($fh); 
	  touch($logfile,time()+$timezone); // update file timestamp
		//save content
		if ($update_content && $fh = @fopen($pth['file']['content'], "w")) {
			fwrite($fh, '<html><head></head><body>'."\n");
			foreach($c as $i) {
				fwrite($fh, rmnl($i."\n"));
			}
			fwrite($fh, '</body></html>');
			fclose($fh);
		}
		$edit=$t_edit; $adm=$t_adm; // reset edit and adm
		rfc();
	} // end of run once af day
	return "";
}
?>